' 
'
'                  Build with either PBCC40 or PBWIN80
'
' 

FUNCTION PBmain as LONG

    LOCAL sp1 as LONG

    sch$ = "dir /b *.asm > dir.txt"                             ' set a batch file command

    Open "sch.bat" for Output as #1                             ' create a temporary batch file
      Print #1, "@echo off"
      Print #1, sch$
    Close #1

    shell "sch.bat"                                             ' synchronously run it to get asm file names
    kill "sch.bat"                                              ' delete it after its finished

    Open "procmap.txt" for Output as #10                        ' create the results file

    Open "dir.txt" for Input as #1                              ' open the file name list
      Do
        Line Input #1, fname$
        Print #10, chr$(13,10)+"; source file = "+fname$        ' print the source file name
          Open fname$ for Input as #2                           ' open each source file
            Do
              Line Input #2, txt$
              txt$ = trim$(txt$)                                ' trim the junk off each line
              Replace chr$(9) with " " in txt$                  ' replace tabs with spaces to simplify parsing

              If txt$ = "" Then                                 ' jump over on blank line
                ! jmp overit
              End If

              If left$(txt$,1) = ";" Then                       ' jump over on comment line
                ! jmp overit
              End If

              If instr(txt$," proc") <> 0 Then                  ' lower case "proc"
                tst$ = mid$(txt$,instr(txt$," proc")+5,1)
                  If asc(tst$) = 32 or asc(tst$) = -1 Then
                    ! jmp Output_Result
                  End If
              End If

              If instr(txt$," PROC") <> 0 Then                  ' upper case "PROC"
                tst$ = mid$(txt$,instr(txt$," PROC")+5,1)
                  If asc(tst$) = 32 or asc(tst$) = -1 Then
                    ! jmp Output_Result
                  End If
              End If

              If instr(txt$," Proc") <> 0 Then                  ' mixed case "Proc"
                tst$ = mid$(txt$,instr(txt$," Proc")+5,1)
                  If asc(tst$) = 32 or asc(tst$) = -1 Then
                    ! jmp Output_Result
                  End If
              End If

              ! jmp nxt
              Output_Result:                                    ' grab the procedure name and print it
                sp1 = instr(txt$," ")
                Print #10, "        ; Procedure name = "+left$(txt$,sp1-1)
            nxt:

            overit:
            Loop while not eof(2)
          Close #2
      Loop while not eof(1)
    Close #1

    Close #10

    kill "dir.txt"                                              ' delete the asm file list file

    x& = shell("\masm32\qeditor.exe procmap.txt",1)

End FUNCTION

' 
